#include <iostream>
#include <vector>
using namespace std;

string s;
int n;
const int N=10010;
bool p[N][N];
vector<int> dp;

void genp()
{
    int n = s.size();
    for (int i = 0; i < n; i++) p[i][i] = true;

    for (int len = 2; len <= n; len++)
    for (int i = 0, j = i + len - 1; j < n ; i++, j++) 
     if (s[i] == s[j] && (len == 2 || p[i + 1][j - 1]))
       p[i][j] = true;
}

int main()
{
	std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);

	cin >> s;
    n = s.size();

    genp();

    // dp[i] stores minimum cuts for palindrome
  	// partitioning of substring s[0...i]
    dp.resize(n, n);
    dp[0] = 0;

    for (int i = 1; i < n; i++)
      if (p[0][i]) dp[i] = 0;
      else
        for (int j = i; j >= 1; j--)
          if (p[j][i])
           dp[i] = min(dp[i], 1 + dp[j-1]);
     cout << dp[n - 1] + 1 << endl;

}



