#include <iostream>
using namespace std;

string s;
const int N=10002;
int memo[N][N];

bool isPalindrome(string& s, int i, int j)
 {
    while (i < j)
    {
        if (s[i] != s[j]) return false;
        i++; j--;
    }
    return true;
}

int rec(string& s, int i, int j)
{

  	if (memo[i][j] != -1) return memo[i][j];
    if (i >= j || isPalindrome(s, i, j)) return memo[i][j] = 0;

    int r = 1e09;
    for (int k = i; k < j; k++)
    {
        int c = 1 + rec(s, i, k) + rec(s, k + 1, j);
        r = min(r, c);
    }

    return memo[i][j] = r;
}

int main()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);

	cin >> s;
  	int n = s.size();
	fill_n(&memo[0][0],N*N,-1);
  	cout << rec(s, 0, n-1) + 1 << endl;
}


